using System;
using System.Drawing;
using System.Windows.Forms;

namespace MyNamespace
{
	/// <summary>
	/// PlotForm is the Windows Form Component for testing the plotting functions in C#
	/// Developed by Michael Gold in 2002 and modified by Harry J. Smith in 2005
	/// See C# Corner at: http://www.c-sharpcorner.com/Code/2002/Aug/XYPlotControl.asp
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>
	public class PlotForm : System.Windows.Forms.Form
	{
		private PlotControl PlotControlXY;
		private System.Windows.Forms.Label labelStartX;
		private System.Windows.Forms.Button buttonStartX;
		private System.Windows.Forms.TextBox textBoxStartX;
		private System.Windows.Forms.Label labelStopX;
		private System.Windows.Forms.Button buttonStopX;
		private System.Windows.Forms.TextBox textBoxStopX;
		private System.Windows.Forms.Button buttonExit;
		private System.ComponentModel.Container components = null;

		private static PlotForm objPlotForm;
		private static float pi = 4.0f * (float)Math.Atan(1.0);
		private static float pi2 = 2.0f * pi;
		private static float dPR = 180f / pi;
		private static float large = 3.40282347E38f;

		private float startX; // not static, one set for each instance of PlotForm
		private float stopX;
		private System.Windows.Forms.Button buttonAbout;
		private System.Windows.Forms.Button buttonSinCos;
		private System.Windows.Forms.Button buttonSinVsCos;
		public static Screen screen;

		public PlotForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.Text = Global.title + " - Run";
			textBoxStartX.Text = "0";
			buttonStartX_Click();
			textBoxStopX.Text = "660";
			buttonStopX_Click();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PlotForm));
			this.buttonSinCos = new System.Windows.Forms.Button();
			this.PlotControlXY = new MyNamespace.PlotControl();
			this.buttonSinVsCos = new System.Windows.Forms.Button();
			this.textBoxStartX = new System.Windows.Forms.TextBox();
			this.labelStartX = new System.Windows.Forms.Label();
			this.buttonStartX = new System.Windows.Forms.Button();
			this.buttonStopX = new System.Windows.Forms.Button();
			this.textBoxStopX = new System.Windows.Forms.TextBox();
			this.labelStopX = new System.Windows.Forms.Label();
			this.buttonExit = new System.Windows.Forms.Button();
			this.buttonAbout = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// buttonSinCos
			// 
			this.buttonSinCos.BackColor = System.Drawing.SystemColors.Control;
			this.buttonSinCos.Location = new System.Drawing.Point(24, 632);
			this.buttonSinCos.Name = "buttonSinCos";
			this.buttonSinCos.Size = new System.Drawing.Size(96, 24);
			this.buttonSinCos.TabIndex = 1;
			this.buttonSinCos.Text = "Sine-Cosine";
			this.buttonSinCos.Click += new System.EventHandler(this.buttonSinCos_Click);
			this.buttonSinCos.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonSinCos_KeyDown);
			// 
			// PlotControlXY
			// 
			this.PlotControlXY.AbsolutePoint = new System.Drawing.Point(-2147483583, -2147483089);
			this.PlotControlXY.BackColor = System.Drawing.SystemColors.Window;
			this.PlotControlXY.ConnectPointsFlag = false;
			this.PlotControlXY.CurrentIndex = 0;
			this.PlotControlXY.LabelX = "";
			this.PlotControlXY.LabelY = "";
			this.PlotControlXY.LineColor = System.Drawing.Color.Blue;
			this.PlotControlXY.Location = new System.Drawing.Point(-24, 16);
			this.PlotControlXY.Name = "PlotControlXY";
			this.PlotControlXY.NumberOfPoints = 0;
			this.PlotControlXY.Size = new System.Drawing.Size(992, 600);
			this.PlotControlXY.TabIndex = 11;
			this.PlotControlXY.XOrigin = 0F;
			this.PlotControlXY.XTickValue = 1F;
			this.PlotControlXY.XValue = -2.147484E+09F;
			this.PlotControlXY.YOrigin = 0F;
			this.PlotControlXY.YTickValue = 1F;
			this.PlotControlXY.YValue = -2.147484E+09F;
			this.PlotControlXY.KeyDown += new System.Windows.Forms.KeyEventHandler(this.PlotControlXY_KeyDown);
			// 
			// buttonSinVsCos
			// 
			this.buttonSinVsCos.BackColor = System.Drawing.SystemColors.Control;
			this.buttonSinVsCos.Location = new System.Drawing.Point(632, 632);
			this.buttonSinVsCos.Name = "buttonSinVsCos";
			this.buttonSinVsCos.Size = new System.Drawing.Size(96, 24);
			this.buttonSinVsCos.TabIndex = 8;
			this.buttonSinVsCos.Text = "Sine vs. Cosine";
			this.buttonSinVsCos.Click += new System.EventHandler(this.buttonSinVsCos_Click);
			this.buttonSinVsCos.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonSinVsCos_KeyDown);
			// 
			// textBoxStartX
			// 
			this.textBoxStartX.Location = new System.Drawing.Point(232, 632);
			this.textBoxStartX.Name = "textBoxStartX";
			this.textBoxStartX.Size = new System.Drawing.Size(56, 20);
			this.textBoxStartX.TabIndex = 3;
			this.textBoxStartX.Text = "0";
			this.textBoxStartX.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxStartX_KeyDown);
			this.textBoxStartX.TextChanged += new System.EventHandler(this.textBoxStartX_TextChanged);
			// 
			// labelStartX
			// 
			this.labelStartX.Location = new System.Drawing.Point(136, 632);
			this.labelStartX.Name = "labelStartX";
			this.labelStartX.Size = new System.Drawing.Size(96, 32);
			this.labelStartX.TabIndex = 2;
			this.labelStartX.Text = "Start X = -999.99";
			// 
			// buttonStartX
			// 
			this.buttonStartX.BackColor = System.Drawing.SystemColors.Control;
			this.buttonStartX.Location = new System.Drawing.Point(288, 632);
			this.buttonStartX.Name = "buttonStartX";
			this.buttonStartX.TabIndex = 4;
			this.buttonStartX.Text = "Change It";
			this.buttonStartX.Click += new System.EventHandler(this.buttonStartX_Click);
			this.buttonStartX.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonStartX_KeyDown);
			// 
			// buttonStopX
			// 
			this.buttonStopX.BackColor = System.Drawing.SystemColors.Control;
			this.buttonStopX.Location = new System.Drawing.Point(528, 632);
			this.buttonStopX.Name = "buttonStopX";
			this.buttonStopX.TabIndex = 7;
			this.buttonStopX.Text = "Change It";
			this.buttonStopX.Click += new System.EventHandler(this.buttonStopX_Click);
			this.buttonStopX.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonStopX_KeyDown);
			// 
			// textBoxStopX
			// 
			this.textBoxStopX.Location = new System.Drawing.Point(472, 632);
			this.textBoxStopX.Name = "textBoxStopX";
			this.textBoxStopX.Size = new System.Drawing.Size(56, 20);
			this.textBoxStopX.TabIndex = 6;
			this.textBoxStopX.Text = "0";
			this.textBoxStopX.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxStopX_KeyDown);
			this.textBoxStopX.TextChanged += new System.EventHandler(this.textBoxStopX_TextChanged);
			// 
			// labelStopX
			// 
			this.labelStopX.Location = new System.Drawing.Point(376, 632);
			this.labelStopX.Name = "labelStopX";
			this.labelStopX.Size = new System.Drawing.Size(96, 32);
			this.labelStopX.TabIndex = 5;
			this.labelStopX.Text = "Stop X = -999.99";
			// 
			// buttonExit
			// 
			this.buttonExit.BackColor = System.Drawing.SystemColors.Control;
			this.buttonExit.Location = new System.Drawing.Point(824, 632);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.Size = new System.Drawing.Size(40, 24);
			this.buttonExit.TabIndex = 10;
			this.buttonExit.Text = "Exit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			this.buttonExit.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonExit_KeyDown);
			// 
			// buttonAbout
			// 
			this.buttonAbout.BackColor = System.Drawing.SystemColors.Control;
			this.buttonAbout.Location = new System.Drawing.Point(752, 632);
			this.buttonAbout.Name = "buttonAbout";
			this.buttonAbout.Size = new System.Drawing.Size(48, 24);
			this.buttonAbout.TabIndex = 9;
			this.buttonAbout.Text = "About";
			this.buttonAbout.Click += new System.EventHandler(this.buttonAbout_Click);
			this.buttonAbout.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonAbout_KeyDown);
			// 
			// PlotForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(992, 694);
			this.Controls.Add(this.buttonAbout);
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.labelStopX);
			this.Controls.Add(this.textBoxStopX);
			this.Controls.Add(this.textBoxStartX);
			this.Controls.Add(this.buttonStopX);
			this.Controls.Add(this.labelStartX);
			this.Controls.Add(this.buttonStartX);
			this.Controls.Add(this.buttonSinVsCos);
			this.Controls.Add(this.PlotControlXY);
			this.Controls.Add(this.buttonSinCos);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "PlotForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "<App.Title> - Run";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			new Global();   // initialize class Global
			screen = Screen.PrimaryScreen;
			// gets the screen size but not used
			Size size = new System.Drawing.Size(screen.Bounds.Width, screen.Bounds.Height);
			objPlotForm = new PlotForm();
			objPlotForm.buttonSinCos_Click();
			Application.Run(objPlotForm);
		}

		private void buttonSinCos_Click(object sender, System.EventArgs e)
		{
			objPlotForm.buttonSinCos_Click();
		}

		private void buttonSinCos_Click()
		{
			if (startX >= stopX) return;
			PlotControlXY.Reset();
			PlotControlXY.NumberOfPens = 3;
			PlotControlXY.XTickValue = (float)Math.Ceiling(((stopX - startX)* PlotControl.kScreenScale) / 
				PlotControl.kPixelsForX);
			PlotControlXY.YTickValue = 0.1f;
			PlotControlXY.XOrigin = startX;
			PlotControlXY.YOrigin = -1f;
			PlotControlXY.LabelX = "Angle in Degrees (" + PlotControlXY.XTickValue + " Degrees per tick)";
			PlotControlXY.LabelY = "Amplitude";
			PlotControlXY.AddPen(0, Color.Red, 2f);
			PlotControlXY.m_bConnectPoints = true;
			float dX = 0.75f * PlotControlXY.XTickValue / PlotControl.kScreenScale; // computes y at each x 3/4 pixel
			for (float x = startX; x < stopX; x += dX)
			{
				PlotControlXY.AddPoint(x, (float)Math.Sin((double)(x / dPR)));
			}
			PlotControlXY.AddPoint(stopX, (float)Math.Sin((double)(stopX / dPR)));
			PlotControlXY.AddPen(1, Color.Green, 2f);
			for (float x = startX; x < stopX; x += dX)
			{
				PlotControlXY.AddPoint(x, (float)Math.Cos((double)(x / dPR)));
			}
			PlotControlXY.AddPoint(stopX, (float)Math.Cos((double)(stopX / dPR)));
			PlotControlXY.AddPen(2, Color.Blue, 1f);
			PlotControlXY.AddPoint(startX, 0f);
			PlotControlXY.AddPoint(stopX, 0f);
			PlotControlXY.Invalidate();
		}

		private void buttonSinVsCos_Click(object sender, System.EventArgs e)
		{
			PlotControlXY.Reset();
			PlotControlXY.XTickValue = 0.1f;
			PlotControlXY.YTickValue = 0.1f;
			PlotControlXY.XOrigin = -1.5f;
			PlotControlXY.YOrigin = -1f;
			PlotControlXY.LabelX = "Sine of Angle";
			PlotControlXY.LabelY = "Cosine of Angle";
			PlotControlXY.NumberOfPens = 1;
			PlotControlXY.AddPen(0, Color.Green, 2f);
			PlotControlXY.m_bConnectPoints = false;
			for (float i = 0f; i < pi2; i += pi2/500f)
			{
				PlotControlXY.AddPoint((float)Math.Sin((double)i), (float)Math.Cos((double)i));
			}
			PlotControlXY.Invalidate();
		}

		private void textBoxStartX_TextChanged(object sender, System.EventArgs e)
		// process input of StartX
		{
			textBoxStartX.Text = textBoxStartX.Text.TrimStart(' ');			// remove leading spaces
			if (textBoxStartX.Text == "")
			{
				buttonStartX.Enabled = true;
				return;
			}
			string sNum = textBoxStartX.Text;
			buttonStartX.Enabled = IsFloat(sNum);
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxStartX.Text = textBoxStartX.Text.Trim(' ');			// remove trailing spaces
					textBoxStartX.SelectionStart = textBoxStartX.Text.Length;	// move to right end of input
					if (buttonStartX.Enabled) buttonStartX_Click();				// accept the input
				}
			}
		}

		private void textBoxStartX_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in StartX box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonStartX.Enabled) buttonStartX_Click();
			}
			TestExit(e);
		}

		private void buttonStartX_Click(object sender, System.EventArgs e)
		{
			buttonStartX_Click();
		}

		private void buttonStartX_Click()
		{
			if (textBoxStartX.Text != "")				// if "", set to current
				startX = (float)Convert.ToDouble(textBoxStartX.Text);
			textBoxStartX.Text = startX.ToString();
			DisplayStartX();
			textBoxStartX.Focus();
			textBoxStartX.SelectionStart = textBoxStartX.Text.Length;		
		}
		private void DisplayStartX() // display StartX
		{
			labelStartX.Text = "Start X = " + startX;
		}

		private void textBoxStopX_TextChanged(object sender, System.EventArgs e)
		// process input of StopX
		{
			textBoxStopX.Text = textBoxStopX.Text.TrimStart(' ');		// remove leading spaces
			if (textBoxStopX.Text == "")
			{
				buttonStopX.Enabled = true;
				return;
			}
			string sNum = textBoxStopX.Text;
			buttonStopX.Enabled = IsFloat(sNum);
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxStopX.Text = textBoxStopX.Text.Trim(' ');			// remove trailing spaces
					textBoxStopX.SelectionStart = textBoxStopX.Text.Length;		// move to right end of input
					if (buttonStopX.Enabled) buttonStopX_Click();				// accept the input
				}
			}
		}

		private void textBoxStopX_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in StopX box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonStopX.Enabled) buttonStopX_Click();
			}
			TestExit(e);
		}

		private void buttonStopX_Click(object sender, System.EventArgs e)
		{
			buttonStopX_Click();
		}

		private void buttonStopX_Click()
		{
			if (textBoxStopX.Text != "")			// if "", set to current
				stopX = (float)Convert.ToDouble(textBoxStopX.Text);
			textBoxStopX.Text = stopX.ToString();
			DisplayStopX();
			textBoxStopX.Focus();
			textBoxStopX.SelectionStart = textBoxStopX.Text.Length;		
		}
		private void DisplayStopX() // display StopX
		{
			labelStopX.Text = "Stop X = " + stopX;
		}

		public static bool IsFloat(string st) // is input string a good double?
		{
			double dFloat;
			try
			{
				dFloat = (float)System.Double.Parse(st);
				if (-large <= dFloat && dFloat <= large)
					return true;
				else
					return false;
			}
			catch // (FormatException ex)
			{
				return false;
			}
		}

		private void buttonExit_Click(object sender, System.EventArgs e)
		// exit the program
		{
			this.Close(); // memberFormClosing will do the work
		}

		private void buttonSinCos_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonAbout_Click(object sender, System.EventArgs e)
			// bring up information about this program
		{
			try
			{
				AboutForm aboutForm = new AboutForm();
				aboutForm.ShowDialog();
				if (aboutForm.DialogResult == DialogResult.Cancel)
				{
					aboutForm.Dispose();
				}
			}
			catch (Exception ex)
			{
				System.Console.WriteLine(ex.Message.ToString());
			}
		}

		private void buttonStopX_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonSinVsCos_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonAbout_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonExit_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonStartX_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void PlotControlXY_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void TestExit(System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape)
			{
				Dispose(true);
			}
		}
	}
}
